# = mQɐK Legendre ֐Cu
#    (C) Takeshi Horinouchi
#    Licence: Ruby's
# 
# ToDo: GaussܓxƏd݌vZ\bh~D

require "narray"

# = mQɐK Legendre ֐
#
module AssocLegendre
  include NMath
  module_function

  # = P_m^m (P_n^m  n=m ̏ꍇ) -- P_m^m p m ɊւQɂvZ
  # x: 1D double NArray
  def p_m_m(x,mmax)
    len=x.length
    pmm = NArray.dfloat(len,mmax+1)
    pmm[true,0] = 1      # l: m=0 ͓̉IȊ֐
    for m in 0..mmax-1
      pmm[true,m+1] = sqrt( (2*m+3.0)/(2*m+2.0) ) * sqrt(1-x*x) * pmm[true,m]
    end
    pmm
  end

  # = P_m+1^m (P_n^m  n=m+1 ̏ꍇ) -- P_m+1^m p m ɊւQɂvZ
  # x: 1D double NArray
  def p_m1_m(x,mmax)
    len=x.length
    pm1m = NArray.dfloat(len,mmax+1)
    pm1m[true,0] = sqrt(3.0) * x      # l: m=0 ͓̉IȊ֐
    for m in 0..mmax-1
      pm1m[true,m+1] = sqrt( (2*m+5.0)/(2*m+2.0) ) * sqrt(1-x*x) * pm1m[true,m]
    end
    pm1m
  end

  # = n ɊւQ (mŒ) gāCP_n^m, n=m+2, m+3,...,2m ߂
  # (slӌ`ؒf)
  def p_n_m(x,pmm,pm1m)
    len, ms = pmm.shape
    mmax = ms - 1
    pnm = NArray.dfloat(len, mmax+1, mmax+1)
    pnm[true,true,0] = pmm
    pnm[true,true,1] = pm1m
    for m in 0..mmax
      for n in m+1..m+mmax-1
        s = n-m
        pnm[true,m,s+1] = 
             sqrt( (2*n+3.0)*(2*n+1)/(n+m+1)/(n-m+1) ) * x * pnm[true,m,s] -
             sqrt( (2*n+3.0)*(n+m)*(n-m)/(2*n-1)/(n+m+1)/(n-m+1) ) * 
                                                         pnm[true,m,s-1]
      end
    end
    pnm
  end

  # = mǂ -- ƃT{ēԊup` 
  # pnm : 1D NArray
  def norm(pnm)
    p2 = pnm*pnm
    len = p2.length
    (2.0/len) * ( (p2[0]+p2[len-1])/2 + p2[1..len-2].sum )
  end
end

#############################################################
#### ȉ̓CũeXg -- m(ߎ)Ɛ} #######
if $0 == __FILE__
  require "numru/dcl"
  include AssocLegendre
  include NumRu

  wsn = ( ARGV[0] || 1 ).to_i

  len = 101
  x = NArray.dfloat(len).indgen!*(2.0/(len-1)) - 1
  mmax = 5
  pmm = p_m_m(x,mmax)
  pm1m = p_m1_m(x,mmax)
  pnm = p_n_m(x,pmm,pm1m)
  for m in 0..mmax
    printf( "%d\t%10.8f\t%10.8f\n", m, norm(pmm[true,m]), norm(pm1m[true,m]) )
  end
  for m in 0..mmax
    for s in 0..mmax
      printf( "%d  %d\t%10.8f\n", m,s, norm(pnm[true,m,s]) )
    end
  end

  DCL.swpset('iwidth',900)
  DCL.swpset('iheight',600)
  DCL.swpset('ldump',true) if wsn==4
  DCL.gropn(wsn)
  DCL.sldiv('y',3,2)
  DCL.uzfact(1.1)

=begin
  DCL.grfrm
  DCL.grswnd(-1.0, 1.0, -3.0, 3.0)
  DCL.grsvpt(0.1, 0.9, 0.1, 0.9)
  DCL.grstrf
  DCL.usgrph(x,pmm[true,0])
  for m in 1..mmax
    DCL.sgplu(x,pmm[true,m])
  end

  DCL.grfrm
  DCL.grswnd(-1.0, 1.0, -3.0, 3.0)
  DCL.grsvpt(0.1, 0.9, 0.1, 0.9)
  DCL.grstrf
  DCL.usgrph(x,pm1m[true,0])
  for m in 1..mmax
    DCL.sgplu(x,pm1m[true,m])
  end
=end

  for m in 0..mmax
    DCL.grfrm
    DCL.grswnd(-1.0, 1.0, -3.0, 3.0)
    DCL.grsvpt(0.1, 0.9, 0.1, 0.9)
    DCL.grstrf
    DCL.usdaxs
    DCL.sgpset('lchar',true)
    for s in 0..mmax
      DCL.sgsplc("n=#{m+s}")
      DCL.sgplu(x,pnm[true,m,s])
    end
    DCL.uxmttl('t',"m=#{m}",0.0)
    DCL.sgpset('lchar',false)
  end

  DCL.grcls
end
